diff --git a/gcc/analyzer/path-state.h b/gcc/analyzer/path-state.h
new file mode 100644
index 0000000..68edf80
--- /dev/null
+++ b/gcc/analyzer/path-state.h
@@ -0,0 +1,315 @@
+/* Tracking equivalence classes and constraints at a point on an execution path.
+   Copyright (C) 2019 Free Software Foundation, Inc.
+   Contributed by David Malcolm <dmalcolm@redhat.com>.
+
+This file is part of GCC.
+
+GCC is free software; you can redistribute it and/or modify it
+under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 3, or (at your option)
+any later version.
+
+GCC is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GCC; see the file COPYING3.  If not see
+<http://www.gnu.org/licenses/>.  */
+
+#ifndef GCC_ANALYZER_PATH_STATE_H
+#define GCC_ANALYZER_PATH_STATE_H
+
+class superedge;
+class call_superedge;
+class return_superedge;
+
+/* FIXME: put everything to do with path_state in its own namespace
+   while building up the alternative impl.  */
+
+namespace psn {
+
+/* One of the end-points of a range.  */
+
+struct bound
+{
+  bound () : m_constant (NULL_TREE), m_closed (false) {}
+  bound (tree constant, bool closed)
+  : m_constant (constant), m_closed (closed) {}
+
+  void ensure_closed (bool is_upper);
+
+  tree m_constant;
+  bool m_closed;
+};
+
+/* FIXME.  */
+
+struct range
+{
+  range () : m_lower_bound (), m_upper_bound () {}
+  range (const bound &lower, const bound &upper)
+  : m_lower_bound (lower), m_upper_bound (upper) {}
+
+  std::string to_str () const;
+
+  bool constrained_to_single_element (tree *out);
+
+  bound m_lower_bound;
+  bound m_upper_bound;
+};
+
+} // namespace psn
+
+/* A tree, extended with stack frame information for locals, so that
+   we can distinguish between different values of locals within a potentially
+   recursive callstack.  */
+
+class path_var
+{
+public:
+  path_var (tree t, int stack_depth)
+  : m_tree (t), m_stack_depth (stack_depth)
+  {
+    // TODO: ignore stack depth for globals and constants
+  }
+
+  bool operator== (const path_var &other) const
+  {
+    return (m_tree == other.m_tree
+	    && m_stack_depth == other.m_stack_depth);
+  }
+
+  std::string to_str () const;
+
+  tree m_tree;
+  int m_stack_depth; // or -1 for globals?
+};
+
+/* FIXME: put everything to do with path_state in its own namespace
+   while building up the alternative impl.  */
+
+namespace psn {
+
+/* Abstract base class for specifying how state should be purged.  */
+
+class purge_criteria
+{
+public:
+  virtual ~purge_criteria () {}
+  virtual bool should_purge_p (path_var pv) const = 0;
+};
+
+} // namespace psn
+
+
+class path_state;
+
+namespace psn {
+
+/* Optional per-engine extra state (to avoid making path_state a
+   template).  */
+
+class extra_ec_state
+{
+ public:
+  virtual ~extra_ec_state () {}
+  virtual extra_ec_state *clone () const = 0;
+  virtual std::string to_str () const = 0;
+  virtual hashval_t hash () const = 0;
+  virtual bool operator== (const extra_ec_state &other) const = 0;
+};
+
+/* FIXME.  */
+
+class equiv_class
+{
+public:
+  equiv_class ();
+  equiv_class (const equiv_class &other);
+  ~equiv_class ();
+
+  std::string to_str () const;
+  hashval_t hash () const;
+  bool operator== (const equiv_class &other);
+
+  void add (path_var v);
+  bool del (path_var v);
+
+  tree get_any_constant () const { return m_constant; }
+
+  int get_min_stack_depth () const;
+
+  path_var get_representative () const;
+
+  /* An equivalence class can contain at most one constant.  */
+  tree m_constant;
+
+  // FIXME: this is a bad representation, probably should be a set:
+  auto_vec<path_var> m_vars;
+
+  /* Has this value escaped from this function?  */
+  bool m_escaped;
+
+  /* Optional per-engine extra state (to avoid making path_state a
+     template).  */
+  extra_ec_state *m_extra_state;
+};
+
+enum constraint_op
+{
+  CONSTRAINT_NE,
+  CONSTRAINT_LT,
+  CONSTRAINT_LE
+};
+
+const char *constraint_op_code (enum constraint_op c_op);
+
+class equiv_class_id
+{
+public:
+  equiv_class_id (unsigned idx) : m_idx (idx) {}
+  const equiv_class &get_obj (const path_state &ps) const;
+  equiv_class &get_obj (path_state &ps) const;
+
+  bool operator== (const equiv_class_id &other) const
+  {
+    return m_idx == other.m_idx;
+  }
+  bool operator!= (const equiv_class_id &other) const
+  {
+    return m_idx != other.m_idx;
+  }
+
+  std::string to_str () const
+  {
+    return std::string ("ec") + std::to_string (m_idx);
+  }
+
+  void update_for_removal (equiv_class_id other)
+  {
+    if (m_idx > other.m_idx)
+      m_idx--;
+  }
+
+  unsigned m_idx;
+};
+
+class constraint {
+ public:
+  constraint (equiv_class_id lhs, enum constraint_op c_op, equiv_class_id rhs)
+    : m_lhs (lhs), m_op (c_op), m_rhs (rhs) {}
+
+  std::string to_str (const path_state &ps) const;
+  hashval_t hash () const;
+  bool operator== (const constraint &other) const;
+
+  /* Is this an ordering, rather than a "!=".  */
+  bool is_ordering_p () const
+  {
+    return m_op != CONSTRAINT_NE;
+  }
+
+  equiv_class_id m_lhs;
+  enum constraint_op m_op;
+  equiv_class_id m_rhs;
+};
+
+} // namespace psn
+
+/* The state of a particular point at one point in the traversal (not including
+   state-machine information).  */
+
+class path_state
+{
+public:
+  path_state () : m_stack_depth (0) {}
+  path_state (const path_state &other);
+  ~path_state ();
+
+  path_state& operator= (const path_state &other);
+
+  hashval_t hash () const;
+  bool operator== (const path_state &other) const;
+  bool operator!= (const path_state &other) const
+  {
+    return !(*this == other);
+  }
+
+  std::string to_str () const;
+
+  const psn::equiv_class &get_equiv_class_by_index (unsigned idx) const
+  {
+    return *m_equiv_classes[idx];
+  }
+  psn::equiv_class &get_equiv_class_by_index (unsigned idx)
+  {
+    return *m_equiv_classes[idx];
+  }
+
+  psn::equiv_class &get_equiv_class (path_var pv)
+  {
+    psn::equiv_class_id ec_id = get_or_add_equiv_class (pv);
+    return ec_id.get_obj (*this);
+  }
+
+  path_var make_path_var (tree expr) const
+  {
+    return path_var (expr, m_stack_depth);
+  }
+
+  void on_assignment (path_var lhs, path_var rhs);
+
+  bool apply_constraints_for_edge (const superedge &edge,
+				   const gimple *last_stmt);
+
+  bool add_constraint (path_var lhs, enum tree_code op, path_var rhs);
+
+  bool add_constraint (psn::equiv_class_id lhs_ec_id,
+		       enum tree_code op,
+		       psn::equiv_class_id rhs_ec_id);
+
+  //private:
+  bool apply_constraints_for_call (const call_superedge& edge);
+
+  bool apply_constraints_for_return (const return_superedge& edge);
+
+  void pop_stack_frame ();
+
+  bool apply_constraints_for_gcond (const superedge &edge,
+				    const gcond *cond_stmt);
+  bool apply_constraints_for_gswitch (const superedge &edge,
+				      const gswitch *switch_stmt);
+  bool get_equiv_class (path_var pv, psn::equiv_class_id *out) const;
+  psn::equiv_class_id get_or_add_equiv_class (path_var vr);
+  tristate eval_condition (psn::equiv_class_id lhs,
+			   enum tree_code op,
+			   psn::equiv_class_id rhs);
+
+  /* For implementing "__analyzer_eval".  */
+  tristate dump_condition (tree lhs, enum tree_code op, tree rhs);
+
+  void recursively_mark_as_escaping (psn::equiv_class_id ec_id);
+  bool calc_escaped_p (path_var pv);
+
+  int purge (const psn::purge_criteria &p);
+
+  void validate () const;
+
+  auto_vec<psn::equiv_class *> m_equiv_classes;
+  auto_vec<psn::constraint> m_constraints;
+  int m_stack_depth;
+
+ private:
+  void add_constraint_internal (psn::equiv_class_id lhs_id,
+				enum psn::constraint_op c_op,
+				psn::equiv_class_id rhs_id);
+};
+
+namespace inchash
+{
+  extern void add_path_var (path_var pv, hash &hstate);
+} // namespace inchash
+
+#endif /* GCC_ANALYZER_PATH_STATE_H */
